//****************************************************************************
//	apci8815w.pas
//
//	aPCI-8815
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	Date 1998/03/05
//
//****************************************************************************

unit apci8815w;

interface

uses
	Windows;

//-----------------------------------------------------------
// Miscellaneous
//-----------------------------------------------------------
const
	APCI8815_MAX_SLOTS = 16;		      { Maximum number of slots }

  APCI8815_SLOT_AUTO = Word(not 0); { default search }

	APCI8815_BUFF_PCH_MAX = 4096;			{ 1ٓA/Dޯ̧MAX }

  APCI8815_CH_MAX  = 16;            { A/Dِ }

//-----------------------------------------------------------
//	Device ID
//-----------------------------------------------------------
const
	APCI8815_VENDOR_ID = $136C;
	APCI8815_DEVICE_ID = $8815;

//-----------------------------------------------------------
// Error codes
//-----------------------------------------------------------
const
	APCI8815_ERR_SYSTEM				    = 5000; { Windows  GetLastError() R[ĂB}
											                  { ̃tH_ɃhCoȂ\܂B}
	APCI8815_ERR_NO_DEVICE			  = 5001; { gp\ȃfoCX܂B}
	APCI8815_ERR_IN_USE				    = 5002; { w̃foCX͎gpłB}
	APCI8815_ERR_INVALID_ARGUMENT = 5003; { Invalid Argument(s) }
	APCI8815_ERR_INVALID_SLOT		  = 5004; { Ș_XbgłB}
	APCI8815_ERR_NOT_CREATED		  = 5005; { foCXNGCgĂ܂B}
	APCI8815_ERR_CHANNEL			    = 5006; { `lݒ肪słB}
	APCI8815_ERR_TIMER				    = 5007; { ^C}lsłB}
	APCI8815_ERR_NOT_ENOUGH_MEM		= 5008; { \ȃmۂł܂łB}
	APCI8815_ERR_INVALID_FUNC		  = 5009; { Ȋ֐ĂяołB}
	APCI8815_ERR_NUMDATA			    = 5010; { w肳ꂽ̃f[^obt@ɑ݂܂B}

	APCI8815_ERR_INTERNAL			    = 5100; { Send mail to us }
	APCI8815_ERR_UNKNOWN			    = 5101; { Help me! }
	APCI8815_SUCCESS				      = 0;    { Successfully proccessed }

	APCI8815_ERR_RESOURCE			    = 5011; { Resource exhaustion }
	APCI8815_ERR_START				    = 5012; { X^[gɎs܂B}

//-----------------------------------------------------------
// Resource infomation structure
//-----------------------------------------------------------
const
	APCI8815_MAX_MEM = 9;		{ number of memory windows }
	APCI8815_MAX_IO	 = 20;	{ number of i/o windows }
	APCI8815_MAX_IRQ = 7;		{ number of irqs }
	APCI8815_MAX_DMA = 7;		{ number of dmas }

type
	TAPCI8815RESOURCE = record
		dwNumMemWindows: DWord;						                      { Not used }
		dwMemBase:      array [1 .. APCI8815_MAX_MEM] of DWord; { Not used }
		dwMemLength:    array [1 .. APCI8815_MAX_MEM] of DWord;	{ Not used }
		dwMemAttrib:    array [1 .. APCI8815_MAX_MEM] of DWord;	{ Not used }
		dwNumIOPorts:   DWord;																  { Num IO ports }
		dwIOPortBase:   array [1 .. APCI8815_MAX_IO] of DWord;	{ I/O port base }
		dwIOPortLength: array [1 .. APCI8815_MAX_IO] of DWord;	{ I/O port length }
		dwNumIRQs:      DWord;																  { Num IRQ info }
		dwIRQRegisters: array [1 .. APCI8815_MAX_IRQ] of DWord;	{ IRQ list }
		dwIRQAttrib:    array [1 .. APCI8815_MAX_IRQ] of DWord;	{ IRQ Attrib list }
		dwNumDMAs:      DWord;																  { Not used }
		dwDMALst:       array [1 .. APCI8815_MAX_DMA] of DWord;	{ Not used }
		dwDMAAttrib:    array [1 .. APCI8815_MAX_DMA] of DWord;	{ Not used }
		dwReserved1:    array [1 .. 3]                of DWord; {	Not used }
	end;

PAPCI8815R = ^TAPCI8815RESOURCE;

//-----------------------------------------------------------
// Sampling definition
//-----------------------------------------------------------

// TvO[h
const        						// Start Sampling Transfer CLK	 Message offset
	APCI8815_MODE_01 = 1; // soft	 single	  port	   ---	 WM_EOC
	APCI8815_MODE_02 = 2; // soft	 single	  port	   EXTRG WM_EOC
	APCI8815_MODE_03 = 3; // soft	 burst	  port	   timer WM_BUFF_HALF_FULL,BUFF_FULL,
												//								 							 WM_BUFF_OVERFLOW
	APCI8815_MODE_04 = 4; // soft	 burst	  port	   EXTRG WM_BUFF_HALF_FULL,BUFF_FULL,
												//								 							 WM_BUFF_OVERFLOW

// TvOXe[^X
const
	APCI8815_STS_SAMPLING			    = $01;
	APCI8815_STS_EOC				      = $02;
	APCI8815_STS_BUFF_HALF_FULL		= $04;
	APCI8815_STS_BUFF_FULL			  = $08;
	APCI8815_STS_BUFF_OVERFLOW		= $10;
	APCI8815_STS_SAMPLING_OVERRUN = $20;

// Apci8815Create  uWMBase ɐݒ肵lɂāAWM_EOC Ȃǂ
// ItZbglbZ[Wo܂B
{$IFNDEF WM_EOC}
const
	WM_EOC						  = 0; { VOTvO̊ }
	WM_BUFF_HALF_FULL		= 1; { Oobt@̃n[tt }
	WM_BUFF_FULL				= 2; { Oobt@̃t }
	WM_BUFF_OVERFLOW		= 3; { Oobt@̃I[o[t[ }
	WM_SAMPLING_OVERRUN = 4; { `lEI[gECNg̃I[o[ }
{$ENDIF}	{ WM_EOC }

// `lݒl͈̔
const
	APCI8815_CH_FIRST = 0;
	APCI8815_CH_LAST	= 15;

// `lݒl
	APCI8815_CH_01 =	0;
	APCI8815_CH_02 =  1;
	APCI8815_CH_03 =	2;
	APCI8815_CH_04 =	3;
	APCI8815_CH_05 =	4;
	APCI8815_CH_06 =	5;
	APCI8815_CH_07 =	6;
	APCI8815_CH_08 =	7;
	APCI8815_CH_09 =	8;
	APCI8815_CH_10 =  9;
	APCI8815_CH_11 = 10;
	APCI8815_CH_12 = 11;
	APCI8815_CH_13 = 12;
	APCI8815_CH_14 = 13;
	APCI8815_CH_15 = 14;
	APCI8815_CH_16 = 15;

// ^C}ŏlől
const
	APCI8815_TM_MIN	= 35;			  { ݒ肷^C}̍ŏl }
	APCI8815_TM_MAX = 64000000;	{ ݒ肷^C}̍ől }

type
	TAPCI8815MODE = record
		dwChFirst: DWord;		{ TvOJn`l(0-15) }
	  dwChLast:  DWord;		{ TvOI`l(0-15) }
												{ (dwChFirst <= dwChLast) }
		cwBuffer:  DWord;		{ obt@TCY }
												{ Oobt@̏ꍇAIɊmۂłlől }
		dwTimer:   DWord;		{ ^C}ɃZbgl(1-200e6) [0 = 10sA1 = 20s] }
		dwMode:    DWord;		{ 샂[h }
	end;

PAPCI8815M = ^TAPCI8815MODE;

type
	{ A/Dޯ̧ }
	TADBUFF = array [1..APCI8815_CH_MAX, 1..APCI8815_BUFF_PCH_MAX] of Word;
	TVXDBUFF = array [1..(APCI8815_CH_MAX) * (APCI8815_BUFF_PCH_MAX-1)] of Word;
	PADBUFF = ^TADBUFF;
	PVXDNUFF = ^TVXDBUFF;

const
	APCI8815_ERR_WRAPDLL = DWord(-1); { bp[֐G[ }

const
	APCI8815_DLL_NAME = 'apci8815.dll';	{ DLL }


function Apci8815wDllOpen: Boolean;		{ DLL [h }
function Apci8815wDllClose: Boolean;	{ DLL A[h }


{ foCXhCoDLL̃o[W擾 }
function Apci8815wGetVersion(var pdwDllVer: DWord; var pdwDrvVer: DWord): Boolean;


{ foCX̎gp錾 }
function Apci8815wCreate(var pwLogSlot: Word; hWnd: THandle; uWMBase: UInt; var pvInitArg): Boolean;
{ foCX̊J錾 }
function Apci8815wClose(wLogSlot: Word): Boolean;


{ I/O\[X̎擾 }
function Apci8815wGetResource(wLogSlot: Word; pres: PAPCI8815R): Boolean;


{ TvO[h̐ݒ }
function Apci8815wSetMode(wLogSlot: Word; pcmode: PAPCI8815M): Boolean;
{ TvOJn }
function Apci8815wStartSampling(wLogSlot: Word): Boolean;
{ TvO~ }
function Apci8815wStopSampling(wLogSlot: Word): Boolean;
{ TvOEXe[^X̎擾 }
function Apci8815wGetSamplingStatus(wLogSlot: Word; var pcwNumData: DWord; var pdwStatus: DWord): Boolean;
{ TvOς݃f[^̎擾 }
function Apci8815wGetData(wLogSlot: Word; cwNumData: DWord; Data:PADBUFF): Boolean;


{ G[R[h̎擾 }
function Apci8815wGetLastError(wLogSlot: Word): DWord;


{ O͏Ԃ̎擾 }
function Apci8815wGetExIn(wLogSlot: Word; var pdwExIn0: DWord; var pdwExIn1: DWord; var pdwExTrg: DWord): Boolean;


implementation

type
  TApci8815GetVersion = function(var pdwDllVer: DWord; var pdwDrvVer: DWord): Bool; stdcall;
	TApci8815Create = function(var pwLogSlot: Word; hWnd: THandle; uWMBase: UInt; var pvInitArg): Bool; stdcall;
	TApci8815Close = function(wLogSlot: Word): Bool; stdcall;
	TApci8815GetResource = function(wLogSlot: Word; pres: PAPCI8815R): Bool; stdcall;
	TApci8815SetMode = function(wLogSlot: Word; pcmode: PAPCI8815M): Bool; stdcall;
	TApci8815StartSampling = function(wLogSlot: Word): Bool; stdcall;
	TApci8815StopSampling = function(wLogSlot: Word): Bool; stdcall;
	TApci8815GetSamplingStatus = function(wLogSlot: Word; var pcwNumData: DWord; var pdwStatus: DWord): Bool; stdcall;
	TApci8815GetData = function(wLogSlot: Word; cwNumData: DWord; Data:PADBUFF): Bool; stdcall;
	TApci8815GetLastError = function(wLogSlot: Word): DWord; stdcall;
	TApci8815GetExIn = function(wLogSlot: Word; var pdwExIn0: DWord; var pdwExIn1: DWord; var pdwExTrg: DWord): Bool; stdcall;

function Apci8815wGetDllExportFunc: Boolean; forward;

{$J+}
const
	hDLL: THandle = 0;
{$J-}

{ DLL GNX|[g֐AhX̊i[ϐ }
var
	pApci8815GetVersion: TApci8815GetVersion;
	pApci8815Create: TApci8815Create;
	pApci8815Close: TApci8815Close;
	pApci8815GetResource: TApci8815GetResource;
	pApci8815SetMode: TApci8815SetMode;
	pApci8815StartSampling: TApci8815StartSampling;
	pApci8815StopSampling: TApci8815StopSampling;
	pApci8815GetSamplingStatus: TApci8815GetSamplingStatus;
	pApci8815GetData: TApci8815GetData;
	pApci8815GetLastError: TApci8815GetLastError;
	pApci8815GetExIn: TApci8815GetExIn;


//****************************************************************************
// 		apci8815.dll[h
// 		
// ߂l  True
//				s False
//****************************************************************************
function Apci8815wDllOpen: Boolean;
begin
	Result := False;

	if hDLL <> 0 then Exit;

	hDLL := LoadLibrary(APCI8815_DLL_NAME);
	if hDLL = 0 then Exit;

	if Apci8815wGetDllExportFunc = False then
	begin
		Apci8815wDllClose;	// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		Exit;
	end;

	Result := True;
end;

//****************************************************************************
// 		apci8815.dllA[h
// 		
// ߂l  True
//				s False
//****************************************************************************
function Apci8815wDllClose: Boolean;
begin
	Result := True;

	if hDLL = 0 then Exit;

	if FreeLibrary(hDLL) = True then hDLL := 0
	else Result := False;
end;



//****************************************************************************
// 		aPCI-8815 DLL,Driver̃o[Wԍ擾
// 		pdwDllVer DLLo[Wԍi[
//				pdwDrvVer Drivero[Wԍi[
// ߂l  True
//				s False
//****************************************************************************
function Apci8815wGetVersion(var pdwDllVer: DWord; var pdwDrvVer: DWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pApci8815GetVersion(pdwDllVer, pdwDrvVer);
end;

//****************************************************************************
// 		aPCI-8815̔Cӂ̃foCX̎gp錾
// 		pwLogSlot	 gpfoCXi[
//				hWnd			 bZ[W𑗂EBhEnh
//		  	uWMBase		 ƂȂ郁bZ[WID
//				pvInitArg	 gp
// ߂l  True
//				s False
//****************************************************************************
function Apci8815wCreate(var pwLogSlot: Word; hWnd: THandle; uWMBase: UInt; var pvInitArg): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pApci8815Create(pwLogSlot, hWnd, uWMBase, pvInitArg);
end;

//****************************************************************************
// 		aPCI-8815̔Cӂ̃foCX̎gpJ
// 		wLogSlot gpfoCX
// ߂l  True
//				s False
//****************************************************************************
function Apci8815wClose(wLogSlot: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pApci8815Close(wLogSlot);
end;

//****************************************************************************
// 		wfoCX̃\[X擾
// 		wLogSlot ׂfoCX
//				pres		 \[Xi[\
// ߂l  True
//				s False
//****************************************************************************
function Apci8815wGetResource(wLogSlot: Word; pres: PAPCI8815R): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pApci8815GetResource(wLogSlot, pres);
end;

//****************************************************************************
// 		TvO[h̐ݒ
// 	  wLogSlot ݒ肷foCX
//		    pcmode   [hݒf[^
// ߂l  True
//				s False
//****************************************************************************
function Apci8815wSetMode(wLogSlot: Word; pcmode: PAPCI8815M): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pApci8815SetMode(wLogSlot, pcmode);
end;

//****************************************************************************
// 		TvOJn
// 	  wLogSlot JnfoCX
// ߂l  True
//				s False
//****************************************************************************
function Apci8815wStartSampling(wLogSlot: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pApci8815StartSampling(wLogSlot);
end;

//****************************************************************************
// 		TvO~
// 	  wLogSlot ~foCX
// ߂l  True
//				s False
//****************************************************************************
function Apci8815wStopSampling(wLogSlot: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pApci8815StopSampling(wLogSlot);
end;

//****************************************************************************
// 		TvOEXe[^X̎擾
// 	  wLogSlot	 擾foCX
//		    pcwNumData f[^obt@AhX
//		    pdwStatus	 Xe[^XAhX
// ߂l  True
//				s False
//****************************************************************************
function Apci8815wGetSamplingStatus(wLogSlot: Word; var pcwNumData: DWord; var pdwStatus: DWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pApci8815GetSamplingStatus(wLogSlot, pcwNumData, pdwStatus);
end;

//****************************************************************************
// 		TvOς݃f[^̎擾
// 	  wLogSlot	擾foCX
//			  cwNumData vf[^
//			  Data			f[^obt@ւ̃AhX
// ߂l  True
//				s False
//****************************************************************************
function Apci8815wGetData(wLogSlot: Word; cwNumData: DWord; Data:PADBUFF): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pApci8815GetData(wLogSlot, cwNumData, Data);
end;

//****************************************************************************
// 		aPCI-8815̃G[R[h
// 		wLogSlot	G[foCX
// ߂l G[R[h
//****************************************************************************
function Apci8815wGetLastError(wLogSlot: Word): DWord;
begin
	Result := APCI8815_ERR_WRAPDLL;

	if hDLL = 0 then Exit;

	Result := pApci8815GetLastError(wLogSlot);
end;

//****************************************************************************
// 		O͏Ԃ̎擾
// 	  wLogSlot 擾foCX
//		  	pdwExIn0 EXIN0̏
//		  	pdwExIn1 EXIN1̏
//		  	pdwExTrg EXTRG̏
// ߂l  True
//				s False
//****************************************************************************
function Apci8815wGetExIn(wLogSlot: Word; var pdwExIn0: DWord; var pdwExIn1: DWord; var pdwExTrg: DWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pApci8815GetExIn(wLogSlot, pdwExIn0, pdwExIn1, pdwExTrg);
end;

//---------------------------------------------------------------------------
// 		DLLGNX|[g֐AhX̎擾
// 		
// ߂l  True
//				s False
//---------------------------------------------------------------------------
function Apci8815wGetDllExportFunc: Boolean;
begin
	Result := False;

	// Apci8815GetVersion ̃AhX擾
	pApci8815GetVersion := GetProcAddress(hDLL, 'Apci8815GetVersion');
	if @pApci8815GetVersion = nil then Exit;

	// Apci8815Create ̃AhX擾
	pApci8815Create := GetProcAddress(hDLL, 'Apci8815Create');
	if @pApci8815Create = nil then Exit;

	// Apci8815Close ̃AhX擾
	pApci8815Close := GetProcAddress(hDLL, 'Apci8815Close');
	if @pApci8815Close = nil then Exit;

	// Apci8815GetResource ̃AhX擾
	pApci8815GetResource := GetProcAddress(hDLL, 'Apci8815GetResource');
	if @pApci8815GetResource = nil then Exit;

	// Apci8815SetMode ̃AhX擾
	pApci8815SetMode := GetProcAddress(hDLL, 'Apci8815SetMode');
	if @pApci8815SetMode = nil then Exit;

	// Apci8815StartSampling ̃AhX擾
	pApci8815StartSampling := GetProcAddress(hDLL, 'Apci8815StartSampling');
	if @pApci8815StartSampling = nil then Exit;

	// Apci8815StopSampling ̃AhX擾
	pApci8815StopSampling := GetProcAddress(hDLL, 'Apci8815StopSampling');
	if @pApci8815StopSampling = nil then Exit;

	// Apci8815GetSamplingStatus ̃AhX擾
	pApci8815GetSamplingStatus := GetProcAddress(hDLL, 'Apci8815GetSamplingStatus');
	if @pApci8815GetSamplingStatus = nil then Exit;

	// Apci8815GetData ̃AhX擾
	pApci8815GetData := GetProcAddress(hDLL, 'Apci8815GetData');
	if @pApci8815GetData = nil then Exit;

	// Apci8815GetLastError ̃AhX擾
	pApci8815GetLastError := GetProcAddress(hDLL, 'Apci8815GetLastError');
	if @pApci8815GetLastError = nil then Exit;

	// Apci8815GetExIn ̃AhX擾
	pApci8815GetExIn := GetProcAddress(hDLL, 'Apci8815GetExIn');
	if @pApci8815GetExIn = nil then Exit;

	Result := True;	// SĂ DLL GNX|[g֐AhX擾
end;

end.

