Attribute VB_Name = "Wrapper"
'*****************************************************************************
'* apci8815w.bas                                                             *
'*                                                                           *
'* aPCI-8815                                                             *
'*                                                                           *
'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.                                   *
'*                                                                           *
'* Date 1998/04/21                                                           *
'*                                                                           *
'*****************************************************************************
Option Explicit
Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long

Global Const APCI8815_DLL_NAME = "apci8815.dll" ' DLL

Dim hDLL As Long                'DLLւ̃nh

Global Const APCI8815_ERR_WRAPDLL = -1  ' bp[֐G[

'*****************************************************************************
'*    apci8815.dll[h                                               *
'*                                                                   *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Apci8815wDllOpen() As Boolean
    
    Apci8815wDllOpen = False

    If hDLL <> 0 Then Exit Function

    hDLL = LoadLibrary(APCI8815_DLL_NAME)
    If hDLL = 0 Then Exit Function
    
    If Apci8815wGetDllExportFunc() = False Then
        Apci8815wDllClose     ' DLL GNX|[g֐LmFɎŝŁADLL N[Y
        Exit Function
    End If

    Apci8815wDllOpen = True

End Function

'*****************************************************************************
'*    apci8815.dllA[h                                           *
'*                                                                   *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Apci8815wDllClose() As Boolean

    Apci8815wDllClose = True

    If hDLL = 0 Then Exit Function

    If FreeLibrary(hDLL) <> 0 Then hDLL = 0 Else Apci8815wDllClose = False

End Function

'*****************************************************************************
'*    aPCI-8815 DLL,Driver̃o[Wԍ擾                           *
'*    pdwDllVer DLLo[Wԍi[                                  *
'*        pdwDrvVer Drivero[Wԍi[                               *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Apci8815wGetVersion(ByRef pdwDllVer As Long, ByRef pdwDrvVer As Long) As Boolean

    Apci8815wGetVersion = False

    If hDLL = 0 Then Exit Function

    If Apci8815GetVersion(pdwDllVer, pdwDrvVer) = 0 Then Exit Function

    Apci8815wGetVersion = True

End Function

'*****************************************************************************
'*    aPCI-8815̔Cӂ̃foCX̎gp錾                              *
'*    pwLogSlot gpfoCXi[AhX                       *
'*        hWnd      bZ[W𑗂EBhEnh                       *
'*        uWMBase   ƂȂ郁bZ[WID                                   *
'*        pvInitArg gp(0Zbg)                                        *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Apci8815wCreate(ByRef pwLogSlot As Integer, ByVal hWnd As Long, ByVal uWMBase As Long, ByRef pvInitArg As Long) As Boolean

    Apci8815wCreate = False
    
    If hDLL = 0 Then Exit Function

    If Apci8815Create(pwLogSlot, hWnd, uWMBase, pvInitArg) = 0 Then Exit Function

    Apci8815wCreate = True

End Function

'*****************************************************************************
'*    aPCI-8815̔Cӂ̃foCX̎gpJ                              *
'*    wLogSlot gpfoCX                                          *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Apci8815wClose(ByVal wLogSlot As Integer) As Boolean

    Apci8815wClose = False

    If hDLL = 0 Then Exit Function

    If Apci8815Close(wLogSlot) = 0 Then Exit Function

    Apci8815wClose = True

End Function

'*****************************************************************************
'*    wfoCX̃\[X擾                                   *
'*    wLogSlot ׂfoCX                                            *
'*        pres     \[Xi[\                              *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Apci8815wGetResource(ByVal wLogSlot As Integer, ByRef pres As APCI8815RESOURCE) As Boolean
    
    Apci8815wGetResource = False
    
    If hDLL = 0 Then Exit Function

    If Apci8815GetResource(wLogSlot, pres) = 0 Then Exit Function

    Apci8815wGetResource = True

End Function

'*****************************************************************************
'*    TvO[h̐ݒ                                           *
'*    wLogSlot ݒ肷foCX                                          *
'*        pcmode   [hݒf[^̃AhX                                *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Apci8815wSetMode(ByVal wLogSlot As Integer, ByRef pcmode As APCI8815MODE) As Boolean
    
    Apci8815wSetMode = False
    
    If hDLL = 0 Then Exit Function

    If Apci8815SetMode(wLogSlot, pcmode) = 0 Then Exit Function
        
    Apci8815wSetMode = True

End Function

'*****************************************************************************
'*    TvOJn                                                   *
'*    wLogSlot JnfoCX                                          *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Apci8815wStartSampling(ByVal wLogSlot As Integer) As Boolean
    
    Apci8815wStartSampling = False
    
    If hDLL = 0 Then Exit Function

    If Apci8815StartSampling(wLogSlot) = 0 Then Exit Function
    
    Apci8815wStartSampling = True

End Function

'*****************************************************************************
'*    TvO~                                                   *
'*    wLogSlot ~foCX                                          *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Apci8815wStopSampling(ByVal wLogSlot As Integer) As Boolean
    
    Apci8815wStopSampling = False
    
    If hDLL = 0 Then Exit Function

    If Apci8815StopSampling(wLogSlot) = 0 Then Exit Function
    
    Apci8815wStopSampling = True

End Function

'*****************************************************************************
'*    TvOEXe[^X̎擾                                     *
'*    wLogSlot   擾foCX                                        *
'*        pcwNumData f[^obt@                                        *
'*        pdwStatus  Xe[^X                                              *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Apci8815wGetSamplingStatus(ByVal wLogSlot As Integer, ByRef pcwNumData As Long, ByRef pdwStatus As Long) As Boolean
    
    Apci8815wGetSamplingStatus = False
    
    If hDLL = 0 Then Exit Function

    If Apci8815GetSamplingStatus(wLogSlot, pcwNumData, pdwStatus) = 0 Then Exit Function
    
    Apci8815wGetSamplingStatus = True

End Function

'*****************************************************************************
'*    TvOς݃f[^̎擾                                       *
'*    wLogSlot  擾foCX                                         *
'*        cwNumData vf[^                                             *
'*        pwData    f[^obt@                                           *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Apci8815wGetData(ByVal wLogSlot As Integer, ByVal cwNumData As Long, ByRef pwData() As Integer) As Boolean
    
    Apci8815wGetData = False
    
    If hDLL = 0 Then Exit Function

    If Apci8815GetData(wLogSlot, cwNumData, pwData(LBound(pwData))) = 0 Then Exit Function
    
    Apci8815wGetData = True

End Function

'*****************************************************************************
'*    aPCI-8815̃G[R[h                                            *
'*    wLogSlot  G[foCX                                 *
'* ߂l G[R[h                                                       *
'*****************************************************************************
Function Apci8815wGetLastError(ByVal wLogSlot As Integer) As Long
    
    Apci8815wGetLastError = APCI8815_ERR_WRAPDLL
    
    If hDLL = 0 Then Exit Function

    Apci8815wGetLastError = Apci8815GetLastError(wLogSlot)

End Function

'*****************************************************************************
'*    O͏Ԃ̎擾                                                 *
'*    wLogSlot 擾foCX                                          *
'*        pdwExIn0 EXIN0̏                                               *
'*        pdwExIn1 EXIN1̏                                               *
'*        pdwExTrg EXTRG̏                                               *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Apci8815wGetExIn(ByVal wLogSlot As Integer, ByRef pdwExIn0 As Long, ByRef pdwExIn1 As Long, ByRef pdwExTrg As Long) As Boolean
    
    Apci8815wGetExIn = False
    
    If hDLL = 0 Then Exit Function

    If Apci8815GetExIn(wLogSlot, pdwExIn0, pdwExIn1, pdwExTrg) = 0 Then Exit Function

    Apci8815wGetExIn = True

End Function

'*---------------------------------------------------------------------------*
'*    DLLGNX|[g֐L̊mF                                      *
'*                                                                   *
'* ߂l  True                                                          *
'*        s False                                                         *
'*---------------------------------------------------------------------------*
Private Function Apci8815wGetDllExportFunc() As Boolean

    Dim pFunc As Long
    
    Apci8815wGetDllExportFunc = False
    
    ' Apci8815GetVersion ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Apci8815GetVersion")
    If pFunc = 0 Then Exit Function

    ' Apci8815Create ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Apci8815Create")
    If pFunc = 0 Then Exit Function

    ' Apci8815Close ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Apci8815Close")
    If pFunc = 0 Then Exit Function

    ' Apci8815GetResource ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Apci8815GetResource")
    If pFunc = 0 Then Exit Function

    ' Apci8815SetMode ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Apci8815SetMode")
    If pFunc = 0 Then Exit Function

    ' Apci8815StartSampling ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Apci8815StartSampling")
    If pFunc = 0 Then Exit Function

    ' Apci8815StopSampling ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Apci8815StopSampling")
    If pFunc = 0 Then Exit Function

    ' Apci8815GetSamplingStatus ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Apci8815GetSamplingStatus")
    If pFunc = 0 Then Exit Function

    ' Apci8815GetData ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Apci8815GetData")
    If pFunc = 0 Then Exit Function

    ' Apci8815GetLastError ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Apci8815GetLastError")
    If pFunc = 0 Then Exit Function

    ' Apci8815GetExIn ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Apci8815GetExIn")
    If pFunc = 0 Then Exit Function

    Apci8815wGetDllExportFunc = True  ' SĂ DLL GNX|[g֐݂̑mF

End Function
